///////////////////////////////////////////
//																       //
//  Implementaion of Fraction Class      //
//																       //
//					Chungho Chau					       //
//																       //
///////////////////////////////////////////

#include "Fraction.h"
#include <iostream.h>

//--------------------------------------------------------------------------------
//	Op> Constructor
//-------------------------------------------------------------------------------- 
BOOL Fraction::operator> (const Fraction &other) const
{
	return ( double (m_num/m_den) > double (other.m_num/other.m_den) );
}


//--------------------------------------------------------------------------------
//	Copy Constructor
//-------------------------------------------------------------------------------- 
Fraction::Fraction(const Fraction &other)
{
	m_num = other.m_num;
	m_den = other.m_den;
}


//--------------------------------------------------------------------------------
//	Assignment Operator for Fraction object
//-------------------------------------------------------------------------------- 
Fraction &Fraction::operator=(const Fraction &other)
{
	if (this==&other)  // better than *this==other
		return *this;		 // compare what they point to
										 // always for op=
	m_num = other.m_num;
	m_den = other.m_den;
	return *this;
}


//--------------------------------------------------------------------------------
//	Assignment Operator for Integer
//-------------------------------------------------------------------------------- 
Fraction &Fraction::operator=(int other)
{
	m_num = other;
	m_den = 1;
	return *this;
}


//--------------------------------------------------------------------------------
//	Comparison Operator for Fraction object
//-------------------------------------------------------------------------------- 
BOOL Fraction::operator== (const Fraction &other)
{
	//if ((m_num==other.m_num) && (m_den==other.m_den))
	if ( (double)(m_num/m_den) == (double)(other.m_num/other.m_den) )
		return TRUE;
	else
		return FALSE;
}


//--------------------------------------------------------------------------------
//	Comparison Operator for Integer
//-------------------------------------------------------------------------------- 
BOOL Fraction::operator== (int other)
{
	if ( (m_num==other) && (m_den == 1) )
		return TRUE;
	else
		return FALSE;
}


//--------------------------------------------------------------------------------
//	Display Fraction objects
//-------------------------------------------------------------------------------- 
void Fraction::Display (BOOL needCRLF) const
{
	cout << m_num << "/" << m_den;
	if (needCRLF)
		cout << '\n';
}

//--------------------------------------------------------------------------------
//	Operator+ for "Fraction + Fraction"
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator+ (const Fraction &other)
{
	Fraction newF(*this);
	newF += other;
	return newF;
	
	// or it can be done as followed
	// newF.m_num = (m_num * other.m_den) + (m_den * other.m_num);
	// newF.m_den = m_den * other.m_den;		// m_den == this->m_den	
}


//--------------------------------------------------------------------------------
//	Operator+ for "Fraction + Integer"
//  without this, it still works
//  compiler will go to ctor and then op+ for Fraction + Fraction
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator+ (int other)
{ 
	Fraction newF(*this);
	newF += other;
	return newF;
}


//--------------------------------------------------------------------------------
//	Operator+= for Fraction object
//-------------------------------------------------------------------------------- 
void Fraction::operator+= (const Fraction &other)
{
	m_num = (m_num * other.m_den) + (m_den * other.m_num);
	m_den = m_den * other.m_den;	
}


//--------------------------------------------------------------------------------
//	Operator+= for integer 
//-------------------------------------------------------------------------------- 
void Fraction::operator+= (int other)
{
	m_num = m_num + (m_den * other);	
}


//--------------------------------------------------------------------------------
//	Operator-= for Fraction object
//-------------------------------------------------------------------------------- 
void Fraction::operator-= (const Fraction &other)
{
	m_num = (m_num * other.m_den) - (m_den * other.m_num);
	m_den = m_den * other.m_den;	
}


//--------------------------------------------------------------------------------
//	Operator-= for integer 
//-------------------------------------------------------------------------------- 
void Fraction::operator-= (int other)
{
	m_num = m_num - (m_den * other);
}


//--------------------------------------------------------------------------------
//	Operator- for "Fraction - Fraction"
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator- (const Fraction &other)
{
	Fraction newF(*this);
	newF -= other;
	return newF;

}


//--------------------------------------------------------------------------------
//	Operator- for "Fraction - Integer"
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator- (int other)
{ 
	Fraction newF(*this);
	newF -= other;
	return newF;
}


//--------------------------------------------------------------------------------
//	Operator*= for Fraction object
//-------------------------------------------------------------------------------- 
void Fraction::operator*= (const Fraction &other)
{
	m_num = m_num * other.m_num;
	m_den = m_den * other.m_den;	
}


//--------------------------------------------------------------------------------
//	Operator*= for integer 
//-------------------------------------------------------------------------------- 
void Fraction::operator*= (int other)
{
	m_num = m_num * other;	
}


//--------------------------------------------------------------------------------
//	Operator/= for Fraction object
//-------------------------------------------------------------------------------- 
void Fraction::operator/= (const Fraction &other)
{
	m_num = m_num * other.m_den;
	m_den = m_den * other.m_num;	
}


//--------------------------------------------------------------------------------
//	Operator/= for integer 
//-------------------------------------------------------------------------------- 
void Fraction::operator/= (int other)
{
	m_den = m_den * other;	
}


//--------------------------------------------------------------------------------
//	Operator* for "Fraction * Fraction"
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator* (const Fraction &other)
{
	Fraction newF(*this);
	newF *= other;
	return newF;

}


//--------------------------------------------------------------------------------
//	Operator* for "Fraction * Integer"
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator* (int other)
{ 
	Fraction newF(*this);
	newF *= other;
	return newF;
}

//--------------------------------------------------------------------------------
//	Operator/ for "Fraction / Fraction"
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator/ (const Fraction &other)
{
	Fraction newF(*this);
	newF /= other;
	return newF;

}


//--------------------------------------------------------------------------------
//	Operator/ for "Fraction / Integer"
//-------------------------------------------------------------------------------- 
Fraction Fraction::operator/ (int other)
{ 
	Fraction newF(*this);
	newF /= other;
	return newF;
}


//--------------------------------------------------------------------------------
//	Globle function to overload op<<
//-------------------------------------------------------------------------------- 
ostream & operator<< (ostream &output, const Fraction &other)
{
	output << "[" << other.m_num << "/" << other.m_den << "]";
	return output;
}


//--------------------------------------------------------------------------------
//	Globle function to perform "Integer + Fraction object"
//-------------------------------------------------------------------------------- 
Fraction operator+ (int temp, const Fraction &other)
{
	Fraction newF(temp);
	newF += other;
	return newF;
}


//--------------------------------------------------------------------------------
//	Globle function to perform "Integer - Fraction object"
//-------------------------------------------------------------------------------- 
Fraction operator- (int temp, const Fraction &other)
{
	Fraction newF(temp);
	newF -= other;
	return newF;
}


//--------------------------------------------------------------------------------
//	Globle function to perform "Integer * Fraction object"
//-------------------------------------------------------------------------------- 
Fraction operator* (int temp, const Fraction &other)
{
	Fraction newF(temp);
	newF *= other;
	return newF;
}


//--------------------------------------------------------------------------------
//	Globle function to perform "Integer / Fraction object"
//-------------------------------------------------------------------------------- 
Fraction operator/ (int temp, const Fraction &other)
{
	Fraction newF(temp);
	newF /= other;
	return newF;
}


