////////////////////////////////////////////////
//																						//
//	Bubble Sort Function Template					    //
//																						//
//				Chungho Chau												//
//																						//
////////////////////////////////////////////////

#include <string.h>
#include <iostream.h>

enum {SIZE = 5};


template <class T>
void SortArray(T *data, int quantity, int type)
{

	// Out of Range Check
	if (quantity > SIZE)													
		throw ExceptionHandling("Out of Range");

	// Incorrect Order Check
	else if ( (type < 0) || (type >1) )				
		throw ExceptionHandling("Wrong Order");
	
	// Perform Sorting
	else{
		T temp=data[0];

		if (type == 1){
			for (int i=0; i<quantity; ++i){
				for (int x=0; x<quantity-1; ++x){
					if (data[x] > data [x+1]){
						temp = data[x];
						data[x] = data[x+1];
						data[x+1] = temp;
					}
				}
			}
		}
		else {
			for (int i=0; i<quantity; ++i){
				for (int x=0; x<quantity-1; ++x){
					if (data[x] < data [x+1]){
						temp = data[x];
						data[x] = data[x+1];
						data[x+1] = temp;
					}
				}
			}
		}
	}
}


template <class T>
void PrintArray(T *array, int index)
{
	for (int i=0; i< index; ++i)
	{
		cout << array[i]; 
		if ( i < index - 1)
			{cout << ",";}
	}
}


class ExceptionHandling
{
	public:
				ExceptionHandling(const char *s = "Unknown Exception");	
				~ExceptionHandling() {delete [] m_message;}

				ExceptionHandling(const ExceptionHandling &other);

				char *what(void) const { return m_message;}

	private:
				char *m_message;
};



// ctor for ExceptionHandling class
ExceptionHandling::ExceptionHandling(const char *s)
{
	m_message = new char [strlen(s) + 2];
	strcpy (m_message, s);
}

// cctor for ExceptionHandling class
ExceptionHandling::ExceptionHandling(const ExceptionHandling &other)
{
	m_message = new char [strlen(other.m_message) + 2];
	strcpy (m_message, other.m_message);
}

