////////////////////////////////////////////////
//																						//
//	Function Template with Exception Handling	//
//																						//
//				      Chungho Chau									//
//																						//
////////////////////////////////////////////////

#include "SortTemplate.h"
#include <iostream.h>
#include <string.h>


void main()
{
	// ************************
	//  0    = Decending Order
	//  1    = Ascending Order
	//  else = Exception thrown
	// ************************

	int    iArray[SIZE] = {1,56,32,3,53};
	double dArray[SIZE] = {2.3,34.2,3.0,56.7,0.7}; 
	char	 cArray[SIZE] = {'a','d','o','n','i'};

	// Regular array sorting
	cout << "Ascending integer array: ";
	SortArray(iArray, 5, 1);
	PrintArray(iArray, 5);

	cout << "\nDesending double array: ";
	SortArray(dArray, 5, 0);
	PrintArray(dArray, 5);

	cout << "\nAscending character array: ";
	SortArray(cArray, 5, 1);
	PrintArray(cArray, 5);
	cout << endl;

	// Exception Handling for Incorrect Array Range
	try{
		cout << "\nEnter invalid number of element:\n";
		SortArray(iArray,10,1);
	}
	catch(ExceptionHandling oe){
		cout << "Exception: " << oe.what() << '\n';
	}

	// Exception Handling for Incorrect Array Order
	try{
		cout << "\nEnter invalid sorting order:\n";
		SortArray(iArray,5,2);
	}
	catch(ExceptionHandling oe){
		cout << "Exception: " << oe.what() << '\n';
	}

	cout << endl;
}


